/*
 * CameraPositionData.h
 *
 *  Created on: Apr 10, 2010
 *      Author: lziegler
 */

#include "CameraPositionData.h"

using namespace airobots;
using namespace std;
using namespace xmltio;

std::string CameraPositionData::getBaseTag() {
	return "CAMERAPOSITION";
}

std::string CameraPositionData::getTemplate() {
	return std::string("<") + getBaseTag() + "><GENERATOR/>"
			+ Timestamp::getTemplate()
			+ "<PAN rad=\"\" />"
			+ "<TILT rad=\"\" />"
			+ "<ZOOM qual=\"\" />" + "</" + getBaseTag() + ">";
}

CameraPositionData::CameraPositionData() :
	Type("unknown") {
}

double CameraPositionData::getTilt() const {
	return tilt;
}

void CameraPositionData::setTilt(double tilt) {
	this->tilt = tilt;
}

double CameraPositionData::getPan() const {
	return pan;
}

void CameraPositionData::setPan(double pan) {
	this->pan = pan;
}

double CameraPositionData::getZoom() const {
	return zoom;
}

void CameraPositionData::setZoom(double zoom) {
	this->zoom = zoom;
}

void CameraPositionData::sanitizeLocation(xmltio::Location &loc) const {
	
}

void CameraPositionData::fillInto(xmltio::Location &loc) const {

	Type::fillInto(loc);

	loc[XPath("PAN/@rad")] = getPan();

	loc[XPath("TILT/@rad")] = getTilt();

	loc[XPath("ZOOM/@qual")] = getZoom();

}

void CameraPositionData::fromLocation(const xmltio::Location &loc_, CameraPositionData &ctd) {

	Type::fromLocation(loc_, ctd);

	ctd.setPan(extract<double> (loc_[XPath("PAN/@rad")]));

	ctd.setTilt(extract<double> (loc_[XPath("TILT/@rad")]));

	ctd.setZoom(extract<double> (loc_[XPath("ZOOM/@qual")]));

}
