/*
 * CameraTargetData.cpp
 *
 *  Created on: Aug 6, 2009
 *      Author: jwienke
 */

#include "CameraTargetData.h"

using namespace airobots;
using namespace std;
using namespace xmltio;

std::string CameraTargetData::getBaseTag() {
	return "CAMERATARGET";
}

std::string CameraTargetData::getTemplate() {
	return std::string("<") + getBaseTag() + "><GENERATOR/>"
			+ Timestamp::getTemplate()
			+ "<CYLINDRIC dist=\"\" height=\"\"/>"
			+ "<AZIMUTH rad=\"\" />"
			+ "<ZOOM qual=\"\" />" + "</" + getBaseTag() + ">";
}

CameraTargetData::CameraTargetData() :
	Type("unknown") {
}

double CameraTargetData::getDistance() const {
	return distance;
}

void CameraTargetData::setDistance(double distance) {
	this->distance = distance;
}

double CameraTargetData::getHeight() const {
	return height;
}

void CameraTargetData::setHeight(double height) {
	this->height = height;
}

double CameraTargetData::getAzimuth() const {
	return azimuth;
}

void CameraTargetData::setAzimuth(double azimuth) {
	this->azimuth = azimuth;
}

double CameraTargetData::getZoom() const {
	return zoom;
}

void CameraTargetData::setZoom(double zoom) {
	this->zoom = zoom;
}

void CameraTargetData::sanitizeLocation(xmltio::Location &loc) const {
	
}

void CameraTargetData::fillInto(xmltio::Location &loc) const {

	Type::fillInto(loc);

	loc[XPath("CYLINDRIC/@dist")] = getDistance();
	loc[XPath("CYLINDRIC/@height")] = getHeight();

	loc[XPath("AZIMUTH/@rad")] = getAzimuth();

	loc[XPath("ZOOM/@qual")] = getZoom();

}

void CameraTargetData::fromLocation(const xmltio::Location &loc_, CameraTargetData &ctd) {

	Type::fromLocation(loc_, ctd);

	ctd.setDistance(extract<double> (loc_[XPath("CYLINDRIC/@dist")]));
	ctd.setHeight(extract<double> (loc_[XPath("CYLINDRIC/@height")]));

	ctd.setAzimuth(extract<double> (loc_[XPath("AZIMUTH/@rad")]));

	ctd.setZoom(extract<double> (loc_[XPath("ZOOM/@qual")]));

}
