#include "FaceList.h"

using namespace xmltio;
using namespace airobots;
using namespace std;

FaceList::FaceList() {
	faces = std::vector<Face>();
}

FaceList::~FaceList() {
}

std::string FaceList::getTemplate()
{
	return "<" + getBaseTag() + "/>";
}



void FaceList::fromLocation(const xmltio::Location & loc, FaceList & type)
{
	for (XPathIterator i = XPath(getBaseTag()).evaluate(loc); i; ++i) {
		Location l(*i);
		Face face = extract<Face>(l);
		type.addFace(face);
	}
}



void FaceList::fillInto(xmltio::Location & loc) const
{
	loc[XPath("@creator")] = getGenerator();

	vector<Face>::const_iterator i = faces.begin();
	for (; i != faces.end(); ++i) {
		Location faceLoc(Face::getTemplate(), Face::getBaseTag());
		i->fillInto(faceLoc);
		loc.add(faceLoc);
	}
}



std::string FaceList::getBaseTag()
{
	return "OBJECTS";
}



std::vector<Face> FaceList::getFaces()
{
	return faces;
}



void FaceList::addFace(Face face)
{
	faces.push_back(face);
}



void FaceList::sanitizeLocation(xmltio::Location & loc) const
{
	XPath xp(getBaseTag());
	while (XPathIterator i = xp.evaluate(loc)) {
		Location l(*i);
		loc.remove(l);
	}
}


