#ifndef IMAGEDATA_H_
#define IMAGEDATA_H_

#include <xmltio/xmltio.hpp>

#include "Type.h"

namespace airobots {

class ImageData : public Type {

public:

	ImageData();
	virtual ~ImageData();

	static std::string getBaseTag();
	static std::string getTemplate();

	void sanitizeLocation(xmltio::Location &loc) const;
	virtual void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, ImageData &type);

    std::string getColorspace() const;
    int getHeight() const;
    std::string getUri() const;
    int getWidth() const;

    void setColorspace(std::string colorspace);
    void setHeight(int height);
    void setUri(std::string uri);
    void setWidth(int width);

private:

	std::string uri;
	int width;
	int height;
	std::string colorspace;

};

}

#endif /* IMAGEDATA_H_ */
