/*
 * KatanaGripperData.h
 *
 *  Created on: May 25, 2010
 *      Author: ttoenige
 */

#ifndef KATANAGRIPPERDATA_H_
#define KATANAGRIPPERDATA_H_

#include "Type.h"
namespace airobots
{

class KatanaGripperData: public Type
{
public:
	static std::string getBaseTag();

	static std::string getTemplate();

	KatanaGripperData();

	double getForceLeftInsideFar() const;
	double getForceLeftInsideNear() const;
	double getForceRightInsideFar() const;
	double getForceRightInsideNear() const;
	double getInfraredLeftFront() const;
	double getInfraredLeftInsideFar() const;
	double getInfraredLeftInsideNear() const;
	double getInfraredLeftOutside() const;
	double getInfraredMiddle() const;
	double getInfraredRightFront() const;
	double getInfraredRightInsideFar() const;
	double getInfraredRightInsideNear() const;
	double getInfraredRightOutside() const;

	void setForceLeftInsideFar(double forceLeftInsideFar);
	void setForceLeftInsideNear(double forceLeftInsideNear);
	void setForceRightInsideFar(double forceRightInsideFar);
	void setForceRightInsideNear(double forceRightInsideNear);
	void setInfraredLeftFront(double infraredLeftFront);
	void setInfraredLeftInsideFar(double infraredLeftInsideFar);
	void setInfraredLeftInsideNear(double infraredLeftInsideNear);
	void setInfraredLeftOutside(double infraredLeftOutside);
	void setInfraredMiddle(double infraredMiddle);
	void setInfraredRightFront(double infraredRightFront);
	void setInfraredRightInsideFar(double infraredRightInsideFar);
	void setInfraredRightInsideNear(double infraredRightInsideNear);
	void setInfraredRightOutside(double infraredRightOutside);

	void sanitizeLocation(xmltio::Location &loc) const;
	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, KatanaGripperData &type);

private:
	double forceRightInsideNear;
	double forceRightInsideFar;
	double infraredRightOutside;
	double infraredRightFront;
	double infraredRightInsideNear;
	double infraredRightInsideFar;

	double forceLeftInsideNear;
	double forceLeftInsideFar;
	double infraredLeftOutside;
	double infraredLeftFront;
	double infraredLeftInsideNear;
	double infraredLeftInsideFar;

	double infraredMiddle;

};

}
#endif /* KATANAGRIPPERDATA_H_ */
