/*
 * MapAnnotation.h
 *
 *  Created on: Oct 27, 2010
 *      Author: ltwardon
 */

#ifndef MAPANNOTATION_H
#define MAPANNOTATION_

#include <string>
#include <list>
#include "MapArea.h"
#include <xmltio/xmltio.hpp>
#include "Type.h"

namespace airobots {

class MapAnnotation: public Type {

public:

	MapAnnotation();

	static std::string getBaseTag();
	static std::string getTemplate();

	void addArea(MapArea area);
	void setAreas(std::list<MapArea> areas);
	std::list<MapArea> getAreas() const;
	std::list<MapArea> getAreasByType(MapArea::MapAreaType areaType) const;
	std::list<MapArea> getAreasByName(std::string name) const;

	void sanitizeLocation(xmltio::Location &loc) const;
	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, MapAnnotation &type);

private:

	std::list<MapArea> areas;

};

}

#endif /* MAPANNOTATION_H_ */
