/*
 * MapPoint.cpp
 *
 *  Created on: Oct 13, 2010
 *      Author: ltwardon
 */

#include "MapPoint.h"

using namespace std;
using namespace airobots;

namespace airobots {

const std::string MapPoint::unitValue[] = {
				"M",
				"CM",
				"MM",
				"NM"};

const std::string MapPoint::kindValue[] = {
				"WORLD",
				"RELATIVE"};

MapPoint::MapPoint() :
	x(0), y(0), kind(MapPoint::WORLD), unit(MapPoint::M), ref("") {

}

MapPoint::MapPoint(double x, double y) :
		x(x), y(y), kind(MapPoint::WORLD), unit(MapPoint::M), ref("") {

}

MapPoint::MapPoint(double x, double y, MapPoint::Kind kind, MapPoint::Unit unit, string ref) :
		x(x), y(y), kind(kind), unit(unit), ref(ref) {

}

MapPoint::~MapPoint() {

}

double MapPoint::getX() const {
	return x;
}

void MapPoint::setX(double x) {
	this->x = x;
}

double MapPoint::getY() const {
	return y;
}

void MapPoint::setY(double y) {
	this->y = y;
}

MapPoint::Kind MapPoint::getKind() const {
	return kind;
}

void MapPoint::setKind(MapPoint::Kind kind) {
	this->kind = kind;
}

MapPoint::Unit MapPoint::getUnit() const {
	return unit;
}

void MapPoint::setUnit(MapPoint::Unit unit) {
	this->unit = unit;
}

std::string MapPoint::getRef() const {
	return ref;
}

void MapPoint::setRef(std::string ref) {
	this->ref = ref;
}

}
