/*
 * MapPoint.h
 *
 *  Created on: Oct 13, 2010
 *      Author: ltwardon
 */

#ifndef MAPPOINT_H_
#define MAPPOINT_H_

#include <string>

namespace airobots {

class MapPoint {

public:

	enum Unit{
		M,
		CM,
		MM,
		NM
	};

	static const std::string unitValue[];

	enum Kind{
		WORLD,
		RELATIVE
	};

	static const std::string kindValue[];

	MapPoint();
	MapPoint(double x, double y);
	MapPoint(double x, double y, Kind kind, Unit unit, std::string ref);
	virtual ~MapPoint();

	double getX() const;
	void setX(double x);
	double getY() const;
	void setY(double y);
	Kind getKind() const;
	void setKind(Kind kind);
	Unit getUnit() const;
	void setUnit(Unit unit);
	std::string getRef() const;
	void setRef(std::string ref);

private:

	double x;
	double y;
	Kind kind;
	Unit unit;
	std::string ref;

};

}

#endif /* MAPPOINT_H_ */
