#ifndef OBJECTLOCATIONLIST_H_
#define OBJECTLOCATIONLIST_H_

#include <string>
#include <vector>
#include <list>

#include <xmltio/xmltio.hpp>

#include "Type.h"
#include "ObjectLocationData.h"

namespace airobots {

/**
 * Results of the object recognition.
 *
 * @author lziegler
 */
class ObjectLocationList: public std::vector<ObjectLocationData>, public Type {

public:

	static std::string getBaseTag();

	static std::string getTemplate();

	ObjectLocationList();
	ObjectLocationList(std::string generator);

	virtual bool operator==(const ObjectLocationList &other) const;

	void sanitizeLocation(xmltio::Location&) const;
	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc,
			ObjectLocationList &type);

};

}

#endif /* OBJECTLOCATIONLIST_H_ */
