#include <stdio.h>
#include <sstream>
#include <stdlib.h>

#include "OdometryData.h"

using namespace std;
using namespace xmltio;
using namespace airobots;

std::string OdometryData::getTemplate() {

	return "<" + getBaseTag() + ">"
		+ "<GENERATOR/>"
		+ airobots::Timestamp::getTemplate() + MicroTimestamp::getTemplate()
		+ "<POSITION ref=\"world\" kind=\"absolute\" x=\"\" y=\"\" theta=\"\" />"
		+ "</" + getBaseTag() + ">";

}

OdometryData::OdometryData() : PositionData(0, 0, 0) {

}

OdometryData::OdometryData(std::string generator, float x, float y,
		float theta) : PositionData(x, y, theta) {

}

void OdometryData::sanitizeLocation(xmltio::Location &loc) const {
	
}

void OdometryData::fillInto(xmltio::Location &loc) const {

	PositionData::fillInto(loc);

	loc[XPath(MicroTimestamp::getBaseTag())] = getReadTime();

}

void OdometryData::fromLocation(const xmltio::Location &loc_, OdometryData &odo) {

	PositionData::fromLocation(loc_, odo);

	odo.setReadTime(extract<MicroTimestamp> (loc_[XPath(
			MicroTimestamp::getBaseTag())]));

}
