#ifndef OdometryData_H
#define OdometryData_H

#include <stdint.h>
#include <string>

#include <xmltio/xmltio.hpp>

#include "PositionData.h"
#include "Ticked.h"

namespace airobots {

/**
 * C++ struct for odometry data
 */
class OdometryData: public PositionData, public Ticked {
public:

	static std::string getTemplate();

	OdometryData();
	OdometryData(std::string generator, float x, float y, float theta);

	void sanitizeLocation(xmltio::Location &loc) const;
	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, OdometryData &type);

};

}

#endif
