#include "PlaneList.h"

using namespace xmltio;
using namespace airobots;
using namespace std;

PlaneList::PlaneList() {

}


PlaneList::PlaneList(std::string generator)
	: Type(generator) {
}


PlaneList::~PlaneList() {

}


std::string PlaneList::getBaseTag() {
	return "PLANES";
}



std::string PlaneList::getTemplate() {
	return "<" + getBaseTag() + "></" + getBaseTag() + ">";
}



void PlaneList::sanitizeLocation(xmltio::Location & loc) const {
	XPath xp(PlaneData::getBaseTag());
	while (XPathIterator i = xp.evaluate(loc)) {
		Location l(*i);
		loc.remove(l);
	}
}



void PlaneList::fromLocation(const xmltio::Location & loc, PlaneList & object) {
	for (XPathIterator iter = XPath(PlaneData::getBaseTag()).evaluate(
			loc); iter; ++iter) {
		Location l(*iter);
		PlaneData data = extract<PlaneData> (l);
		object.push_back(data);
	}
}


void PlaneList::fillInto(xmltio::Location & loc) const {
	for (vector<PlaneData>::const_iterator it = this->begin(); it
			!= this->end(); it++) {

		Location obj(PlaneData::getTemplate(), XPath(
				PlaneData::getBaseTag()));

		it->fillInto(obj);
		loc.add(obj);
	}
}
