/*
 * Point2D.h
 *
 *  Created on: Sep 6, 2010
 *      Author: maschroe
 */

#ifndef POINT2D_H_
#define POINT2D_H_

#include <xmltio/xmltio.hpp>
#include "Type.h"
#include "UnitConverter.h"

namespace airobots {

class Point2D : public Type {
public:
	enum Scope {
		GLOBAL, LOCAL
	};

	Point2D();
	Point2D(float x, float y, LengthUnit unit);
	Point2D(float x, float y, LengthUnit unit, Point2D::Scope scope);
	virtual ~Point2D();

	static std::string getBaseTag();
	static std::string getTemplate();

	Point2D::Scope getScope() const;
	float getX(LengthUnit unit = MILLIMETER) const;
	float getY(LengthUnit unit = MILLIMETER) const;
	void setScope(Point2D::Scope scope);
	void setX(float x, LengthUnit unit);
	void setY(float y, LengthUnit unit);

	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, Point2D &type);
	void sanitizeLocation(xmltio::Location &loc) const;

private:
	float x;
	float y;
	Point2D::Scope scope;
};

}

#endif /* POINT2D_H_ */
