/*
 * PoseData.cpp
 *
 *  Created on: May 25, 2010
 *      Author: ttoenige
 */

#include "PoseData.h"

using namespace airobots;
using namespace std;
using namespace xmltio;

std::string PoseData::getBaseTag()
{
	return "currentarmcoord";
}

std::string PoseData::getTemplate()
{
	return std::string("<") + getBaseTag() + "><GENERATOR/>"
			+ Timestamp::getTemplate() + "<currentxyz x=\"\" y=\"\" z=\"\" />"
			+ "</" + getBaseTag() + ">";
}

PoseData::PoseData() :
	Type("unknown")
{
	// TODO Auto-generated constructor stub

}

double PoseData::getX() const
{
	return x;
}
void PoseData::setX(double x)
{
	this->x = x;
}

double PoseData::getY() const
{
	return y;
}
void PoseData::setY(double y)
{
	this->y = y;
}

double PoseData::getZ() const
{
	return z;
}

void PoseData::setZ(double z)
{
	this->z = z;
}

void PoseData::sanitizeLocation(xmltio::Location &loc) const
{

}

void PoseData::fillInto(xmltio::Location &loc) const
{

	Type::fillInto(loc);

	loc[XPath("currentxyz/@x")] = getX();
	loc[XPath("currentxyz/@y")] = getY();
	loc[XPath("currentxyz/@z")] = getZ();

}

void PoseData::fromLocation(const xmltio::Location &loc_, PoseData &kpd)
{

	Type::fromLocation(loc_, kpd);

	kpd.setX(extract<double> (loc_[XPath("currentxyz/@x")]));
	kpd.setY(extract<double> (loc_[XPath("currentxyz/@y")]));
	kpd.setZ(extract<double> (loc_[XPath("currentxyz/@z")]));

}

