#ifndef PRECISEPOLYGON3D_H_
#define PRECISEPOLYGON3D_H_

#include "Type.h"
#include "Point3D.h"
#include "UnitConverter.h"

namespace airobots {

class PrecisePolygon3D: public Type {

public:

	PrecisePolygon3D();
	PrecisePolygon3D(const PrecisePolygon3D &poly);
	virtual ~PrecisePolygon3D();

	static std::string getBaseTag();
	static std::string getTemplate();

	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, PrecisePolygon3D &pol);
	void sanitizeLocation(xmltio::Location &loc) const;

	virtual bool operator==(const PrecisePolygon3D &other) const;

	void addPoint(double x, double y, double z, LengthUnit unit);
	void addPoint(Point3D point);

	Point3D getCentroid();

protected:

	std::vector<Point3D> list;

};

}

#endif /* PRECISEPOLYGON3D_H_ */
