/** ==========================================================================
 * 
 * @file		Shirt.h --
 * @brief		Header file for btl type Shirt
 *
 * @author	Denis Schulze <dschulze@techfak.uni-bielefeld.de>
 * 
 * 1.0 / 04.06.10 (ds)
 * -from scratch
 * ========================================================================== 
 **/

#ifndef __SHIRT_H__
#define __SHIRT_H__

#include "Percept.h"

namespace airobots {

class Shirt : public Percept {

	public:

		static std::string getBaseTag();
		
		static std::string getTemplate();

		static std::string getPerceptName();

		/** Constructor. */
		Shirt();

		/** Deconstructor. */
		~Shirt();		

		float getAngle() const;
		void setAngle(float angle);
	
		float getAngleVariance() const;
		void setAngleVariance(float variance);

		float getDistance() const;
		void setDistance(float distance);

		float getDistanceVariance() const;
		void setDistanceVariance(float variance);

		void sanitizeLocation(xmltio::Location &loc) const;
		void fillInto(xmltio::Location &loc) const;
		static void fromLocation(const xmltio::Location &loc, Shirt &shirt);

	private:		

		/** The angle to the shirt percept. */
		float angle;

		/** The variance in the angle value. */
		float angleVariance;

		/** The distance to the shirt percept. */
		float distance;

		/** The variance in the distance values. */
		float distanceVariance;

};

}

#endif /* __SHIRT_H__ */
