/*
 * SonarData.cpp
 *
 *  Created on: Nov 4, 2010
 *      Author: ltwardon
 */

#include "SonarData.h"

using namespace airobots;
using namespace std;
using namespace xmltio;

std::string SonarData::getBaseTag()
{
	return "SONARDATA";
}

std::string SonarData::getTemplate()
{
	return std::string("<") + getBaseTag() + "><GENERATOR/>"
			+ Timestamp::getTemplate() + "<DISTLEFT value=\"\" />"
			+ "<DISTRIGHT value=\"\" />"
			+ "</" + getBaseTag() + ">";
}

SonarData::SonarData() :
	Type("unknown")
{

}

SonarData::SonarData(double distanceRight, double distanceLeft) :
	distanceRight(distanceRight), distanceLeft(distanceLeft)
{

}

double SonarData::getDistanceRight() const
{
	return distanceRight;
}
void SonarData::setDistanceRight(double distanceRight)
{
	this->distanceRight = distanceRight;
}

double SonarData::getDistanceLeft() const
{
	return distanceLeft;
}
void SonarData::setDistanceLeft(double distanceLeft)
{
	this->distanceLeft = distanceLeft;
}

void SonarData::sanitizeLocation(xmltio::Location &loc) const
{

}

void SonarData::fillInto(xmltio::Location &loc) const
{

	Type::fillInto(loc);

	loc[XPath("DISTLEFT/@value")] = getDistanceLeft();
	loc[XPath("DISTRIGHT/@value")] = getDistanceRight();

}

void SonarData::fromLocation(const xmltio::Location &loc_, SonarData &sd)
{

	Type::fromLocation(loc_, sd);

	sd.setDistanceLeft(extract<double> (loc_[XPath("DISTLEFT/@value")]));
	sd.setDistanceRight(extract<double> (loc_[XPath("DISTRIGHT/@value")]));

}

