/*
 * SonarData.h
 *
 *  Created on: Nov 4, 2010
 *      Author: ltwardon
 */

#ifndef SONARDATA_H_
#define SONARDATA_H_

#include "Type.h"
namespace airobots
{

class SonarData: public Type
{
public:
	static std::string getBaseTag();

	static std::string getTemplate();

	/**
	 * Returns the left Distance
	 */
	double getDistanceLeft() const;
	void setDistanceLeft(double x);

	/**
	 * Returns the right Distance
	 */
	double getDistanceRight() const;
	void setDistanceRight(double y);

	void sanitizeLocation(xmltio::Location &loc) const;
	virtual void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, SonarData &type);

	SonarData();
	SonarData(double distanceRight, double distanceLeft);

private:
	double distanceRight;
	double distanceLeft;
};

}

#endif /* SONARDATA_H_ */
