#include "StateChangeRequest.h"

using namespace std;
using namespace airobots;
using namespace xmltio;

const std::string StateChangeRequest::STATE_ELEMENT = "STATE";

StateChangeRequest::StateChangeRequest() {
	std::string newStateName = "unknown";
}



StateChangeRequest::~StateChangeRequest() {
}



const std::string StateChangeRequest::getNewStateName() const {
	return newStateName;
}



void StateChangeRequest::setNewStateName(std::string name) {
	newStateName = name;
}



std::string StateChangeRequest::getBaseTag() {
	return "STATECHANGE";
}



std::string StateChangeRequest::getTemplate() {
	return "<" + getBaseTag() + ">" + "<GENERATOR/>"
		+ Timestamp::getTemplate() + "<" + STATE_ELEMENT + "/>" + "</" + getBaseTag() + ">";
}



void StateChangeRequest::fromLocation(const xmltio::Location & loc, StateChangeRequest & scr) {
	Type::fromLocation(loc, scr);
	string stateString = extract<string>(loc[XPath(STATE_ELEMENT)]);
	scr.setNewStateName(stateString);
}



void StateChangeRequest::sanitizeLocation(xmltio::Location & loc) const {

}



void StateChangeRequest::fillInto(xmltio::Location & loc) const {
	Type::fillInto(loc);
	loc[XPath(STATE_ELEMENT)] = getNewStateName();
}


