#ifndef STATECONFIGURATION_H_
#define STATECONFIGURATION_H_

#include "Type.h"
#include <set>

namespace airobots {

class StateConfiguration: public Type {
public:
	StateConfiguration();
	virtual ~StateConfiguration();

	static std::string getBaseTag();
	static std::string getTemplate();

	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, StateConfiguration & sc);
	void sanitizeLocation(xmltio::Location &loc) const;

	void addState(std::string stateName);
	void addStates(std::set<std::string> stateNames);
	void removeAllStates();
	std::set<std::string> getStates();
	const std::string getSystemName() const;
	void setSystemName(std::string name);

private:
	static const std::string STATE_ELEMENT;
	static const std::string SYSTEM_STATES_ELEMENT;
	static const std::string SYSTEM_NAME_ELEMENT;
	std::string systemName;
	std::set<std::string> states;
};

}

#endif /* STATECONFIGURATION_H_ */
