/*
 * Ticked.h
 *
 *  Created on: Aug 6, 2009
 *      Author: jwienke
 */

#ifndef TICKED_H_
#define TICKED_H_

#include "MicroTimestamp.h"

namespace airobots {

/**
 * Base class to be used as mixin that enables data types to also have a
 * timestamp that encodes the creation time of the encapsulated data.
 *
 * @author jwienke
 */
class Ticked {
public:
	Ticked();

	MicroTimestamp getReadTime() const;
	timeval getReadTimeval() const;
	time_t getReadTimeSeconds() const;
	suseconds_t getReadTimeMicroSeconds() const;

	void setReadTime(timeval readTime);
	void setReadTime(MicroTimestamp readTime);

private:
	MicroTimestamp readTime;

};

}

#endif /* TICKED_H_ */
