/*
 * Voice.h
 *
 *  Created on: Aug 21, 2009
 *      Author: jwienke
 */

#ifndef VOICE_H_
#define VOICE_H_

#include "Voice.h"
#include "Percept.h"

#include <string>

namespace airobots {

class Voice: public Percept {
public:

	static std::string getBaseTag();
	static std::string getTemplate();
	static std::string getPerceptName();

	Voice();
	virtual ~Voice();

	float getAngle() const;
	void setAngle(float angle);

	float getAngleVariance() const;
	void setAngleVariance(float angleVariance);

	float getRuntimeDifference() const;
	void setRuntimeDifference(float runtimeDifference);

	float getRuntimeDifferenceVariance() const;
	void setRuntimeDifferenceVariance(float runtimeDifferenceVariance);

	bool operator==(const Voice &other) const;

	void sanitizeLocation(xmltio::Location &loc) const;
	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, Voice &type);

private:
	float angle;
	float runtimeDifference;
	float angleVariance;
	float runtimeDifferenceVariance;

};

std::ostream& operator<<(std::ostream& o, Voice const& voice);

}

#endif /* VOICE_H_ */
