/*
 * utils.h
 *
 *  Created on: Aug 17, 2009
 *      Author: jwienke
 */

#ifndef UTILS_H_
#define UTILS_H_

#include <string>
#include <fstream>

#include <boost/test/unit_test.hpp>

/**
 * Reads a text file to a string.
 *
 * @param filename name of the file relative to the test root.
 */
inline std::string readFile(std::string filename) {

	int argc = boost::unit_test::framework::master_test_suite().argc;
	char** argv = boost::unit_test::framework::master_test_suite().argv;

	if (argc < 2) {
		BOOST_FAIL(
				"No location for resources given. First argument must be the location of resources.");
	}
	std::string root(argv[1]);

	std::string realFileName = root + "/" + filename;
	std::ifstream file(realFileName.c_str());
	if (!file) {
		BOOST_FAIL("Unable to read file " + realFileName);
	}

	std::string contents;
	std::string token;
	getline(file, token);
	while (file) {
		contents += token;
		getline(file, token);
	}

	file.close();

	return contents;

}

#endif /* UTILS_H_ */
