package de.unibi.airobots.btl.data.speechrec;


/**
 * Domain class representing a word in the speech recognizers output. Each
 * part is associated with an acoustic, a language model and a combined
 * score.
 * 
 * @author lschilli
 */
public class UtterancePart implements GrammarSymbol {

	private String word;
	private int id;
	private int begin;
	private int end;
	private double acousticScore;
	private double lmScore;
	private double combinedScore;

	public String getWord() {
		return word;
	}

	public void setWord(String word) {
		this.word = word;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getBegin() {
		return begin;
	}

	public void setBegin(int begin) {
		this.begin = begin;
	}

	public int getEnd() {
		return end;
	}

	public void setEnd(int end) {
		this.end = end;
	}

	public double getAcousticScore() {
		return acousticScore;
	}

	public void setAcousticScore(double acousticScore) {
		this.acousticScore = acousticScore;
	}

	public double getLmScore() {
		return lmScore;
	}

	public void setLmScore(double lmScore) {
		this.lmScore = lmScore;
	}

	public double getCombinedScore() {
		return combinedScore;
	}

	public void setCombinedScore(double combinedScore) {
		this.combinedScore = combinedScore;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String toString() {
		return word + "[" + begin + ".." + end + "]";
	}

}