package de.unibi.airobots.btl.common;

import static org.junit.Assert.*;
import nu.xom.Element;

import org.junit.Test;

/**
 * Test cases for {@link Type}.
 * 
 * @author lziegler
 */
public class PolygonTest {

	@Test
	public void selfCompatibility() throws Exception {

		Polygon p0 = new Polygon();
		p0.addPoint(0, 0);
		p0.addPoint(2, 0);
		p0.addPoint(0, 2);

		Polygon p1 = new Polygon();
		p1.addPoint(0, 0);
		p1.addPoint(2, 0);

		assertFalse("equals() not working", p0.equals(p1));
		assertFalse("equals() not working", p1.equals(p0));

		p1.addPoint(0, 2);

		assertTrue("equals() not working", p0.equals(p1));
		assertTrue("equals() not working", p1.equals(p0));

		p1.addPoint(0, 3);

		assertFalse("equals() not working", p0.equals(p1));
		assertFalse("equals() not working", p1.equals(p0));
		
		p0.addPoint(1, 2);

		assertFalse("equals() not working", p0.equals(p1));
		assertFalse("equals() not working", p1.equals(p0));

		Element element = new Element(Polygon.getBaseTag());
		p0.fillInto(element);
		
		Polygon p2 = Polygon.fromElement(element);
		
		assertTrue("serializing not working", p0.equals(p2));
	}
}
