package de.unibi.airobots.btl.data;

import static org.junit.Assert.*;
import nu.xom.Document;
import nu.xom.Element;

import org.apache.log4j.Logger;
import org.junit.Test;

/**
 * Test cases for {@link Type}.
 */
public class PerceptListTest {
	
	private Logger logger = Logger.getLogger(getClass());

	@Test
	public void selfCompatibility() throws Exception {
		
		final long timestamp = System.currentTimeMillis();
		
		PerceptList<Face> original = new PerceptList<Face>(Face.class);
		original.setGenerator("test");
		original.setTimestamp(timestamp);
		
		Face face1 = new Face();
		face1.setGenerator("facesensor1");
		face1.setTimestamp(timestamp);
		face1.setClassId(1);
		original.addPercept(face1);
		
		Face face2 = new Face();
		face2.setGenerator("facesensor2");
		face2.setTimestamp(timestamp);
		face2.setClassId(2);
		original.addPercept(face2);
		
		Document doc = new Document(new Element(PerceptList.getBaseTag()));
		original.fillInto(doc.getRootElement());
		logger.info(doc.toXML());
		
		PerceptList<Face> parsed = new PerceptList<Face>(Face.class);
		PerceptList.fromElement(doc.getRootElement(), parsed);
		
		assertEquals(original.getGenerator(), parsed.getGenerator());
		assertEquals(original.getTimestamp(), parsed.getTimestamp());
		assertEquals(original.getPercepts().size(), parsed.getPercepts().size());
		assertEquals(original.getPercepts().get(0).getClassId(),
				parsed.getPercepts().get(0).getClassId());
		
	}

}
