package de.unibi.airobots.btl.data;

import static org.junit.Assert.*;
import nu.xom.Document;
import nu.xom.Element;

import org.apache.log4j.Logger;
import org.junit.Test;

/**
 * Test cases for {@link Type}.
 * 
 * @author jwienke
 */
public class PositionDataTest {

	private Logger logger = Logger.getLogger(getClass());

	private class ConcretePositionData extends PositionData {

	}

	@Test
	public void selfCompatibility() throws Exception {

		PositionData original = new ConcretePositionData();
		final long timestamp = System.currentTimeMillis();
		original.setTimestamp(timestamp);
		original.setGenerator("test");
		original.setX(-12.34);
		original.setY(34123.45);
		original.setYaw(1.234);

		Document doc = new Document(new Element(PositionData.getBaseTag()));
		original.fillInto(doc.getRootElement());
		logger.info(doc.toXML());

		ConcretePositionData parsed = new ConcretePositionData();
		PositionData.fromElement(doc.getRootElement(), parsed);

		assertEquals(original.getGenerator(), parsed.getGenerator());
		assertEquals(original.getTimestamp(), parsed.getTimestamp());
		assertEquals(original.getX(), parsed.getX(), 0.0001);
		assertEquals(original.getY(), parsed.getY(), 0.0001);
		assertEquals(original.getYaw(), parsed.getYaw(), 0.0001);

	}

}
