package de.unibi.airobots.btl.data;

import static org.junit.Assert.*;
import nu.xom.Document;
import nu.xom.Element;
import org.apache.log4j.Logger;
import org.junit.Test;

/**
 *
 * @author fsiepman
 */
public class RobotStateTest {

    private Logger logger = Logger.getLogger(getClass());

	@Test
	public void selfCompatibility() throws Exception {

		RobotState original = new RobotState();
		final long timestamp = System.currentTimeMillis();
		original.setTimestamp(timestamp);
		original.setGenerator("test");
		original.setCurrenState(RobotState.RobotStates.DRIVE_TO);
                original.setPreviousState(RobotState.RobotStates.WAITING);
                original.setTargetName("jipabndv");

		Document doc = new Document(new Element(SpeedData.getBaseTag()));
		original.fillInto(doc.getRootElement());
		logger.info(doc.toXML());

		RobotState parsed = new RobotState();
		RobotState.fromElement(doc.getRootElement(), parsed);

		assertEquals(original.getGenerator(), parsed.getGenerator());
		assertEquals(original.getTimestamp(), parsed.getTimestamp());
		assertEquals(original.getCurrenState(), parsed.getCurrenState());
                assertEquals(original.getPreviousState(), parsed.getPreviousState());
                assertEquals(original.getTargetName(), parsed.getTargetName());

	}

}
