package de.unibi.airobots.btl.data;

import static org.junit.Assert.assertEquals;
import nu.xom.Document;
import nu.xom.Element;

import org.apache.log4j.Logger;
import org.junit.Test;

public class StateConfigurationTest {

	private Logger logger = Logger.getLogger(getClass());

	@Test
	public void selfCompatibility() {

		StateConfiguration original = new StateConfiguration();
		final long timestamp = System.currentTimeMillis();
		original.setTimestamp(timestamp);
		original.setGenerator("test");
		original.setSystemName("TestäüößName");
		original.addState("test 1234");
		original.addState("Hallo Weltüß\ndoof");

		Document doc = new Document(
				new Element(StateConfiguration.getBaseTag()));
		original.fillInto(doc.getRootElement());
		logger.info(doc.toXML());

		StateConfiguration parsed = new StateConfiguration();
		StateConfiguration.fromElement(doc.getRootElement(), parsed);

		assertEquals(original.getGenerator(), parsed.getGenerator());
		assertEquals(original.getTimestamp(), parsed.getTimestamp());
		assertEquals(original.getStates(), parsed.getStates());

	}

}
