package de.unibi.airobots.btl.data;

import static org.junit.Assert.*;
import nu.xom.Document;
import nu.xom.Element;

import org.apache.log4j.Logger;
import org.junit.Test;

/**
 * Test cases for {@link Type}.
 * 
 * @author jwienke
 */
public class TypeTest {
	
	private Logger logger = Logger.getLogger(getClass());

	private class ConcreteType extends Type {
	}
	
	@Test
	public void selfCompatibility() {
		
		ConcreteType original = new ConcreteType();
		final long timestamp = System.currentTimeMillis();
		original.setTimestamp(timestamp);
		original.setGenerator("test");
		
		Document doc = new Document(new Element(Type.getBaseTag()));
		original.fillInto(doc.getRootElement());
		logger.info(doc.toXML());
		
		ConcreteType parsed = new ConcreteType();
		Type.fromElement(doc.getRootElement(), parsed);
		
		assertEquals(original.getGenerator(), parsed.getGenerator());
		assertEquals(original.getTimestamp(), parsed.getTimestamp());
		
	}
	
}
