package de.unibi.airobots.btl.data.asu;

import org.junit.Test;

import de.unibi.airobots.btl.TestUtils;
import static org.junit.Assert.*;

/**
 * Tests the frame database.
 * 
 * @author malinke
 */
public final class FrameDBTest {

	private FrameDB db = new FrameDB(TestUtils.makeTestFileName("frames.xml"));

	/**
	 * Test of getFrame method, of class FrameDBOld.
	 */
	@Test
	public void testGetFrame() {
		String frameName = "Modality";
		FrameEntry modality = db.getFrame(frameName);
		assertNotNull(modality);
		assertEquals(frameName, modality.getName());
		assertEquals(frameName, modality.getTopName());
		String emptyName = "";
		FrameEntry empty = db.getFrame(emptyName);
		assertNotNull(empty);
		assertFalse(modality.slotList().contains(empty));
		frameName = "Name_personal";
		FrameEntry namePersonal = db.getFrame(frameName);
		assertNotNull(namePersonal);
		assertFalse(namePersonal.slotList().contains(empty));
		FrameEntry questionObject = db.getFrame("Question_object");
		final int numberOfRelated = 4;
		assertEquals(numberOfRelated, questionObject.slotList().size());
	}

}